#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <stdlib.h>
#include <math.h>
#define MICSEC 1000000
#define MAXN 10000     // MAXN Y MAXREP	son los valores maximos que puede ingresar el usuario, 
#define MAXREP 100		//para el primer y segundo argumento correspondientemente, con estos datos aragorn trabaja bien.

int heapsort(int a[], int N);		/*Funcion de ordenamiento heapsort que se encuentra en heapsort.c*/
int quickSort(int a[], int lo0, int hi0);/*Funcion de ordenamiento quicksort que se encuentra en quicksort.c*/
int *crearreglo(int n);			/*Funcion que crea arreglo con n numeros*/

main(int argc, char *argv[]) {		//argc representa numero entero con cantidad de argumentos
				//argc representa un string con los argumentos ingresados por el usuario
int i,n,j,k,salir=1,*arreglo,*rango,*rango2,n2,rep,*tiempos,*tiempos2,mayor=0,menor=RAND_MAX,mayor2=0,menor2=RAND_MAX;
FILE *archivo1;
time_t ti,tf,mici,micf;				//variables que utiliza gettimeofday para tiempo
   struct timeval ttii,ttff;		//estructura para almacenar tiempo inicial y final
   double dfm,ranguito,ranguito2;  //sumx1 contiene sumatoria del tiempo , sumx2 contiene sumatoria del tiempo^2
					//m es la media del tiempo, s es la desviacion estandar alcuadrado


//******************************************************************************************************//
//******************************************************************************************************//
//Posibles errores
   
	if(argc>3||argc<3||argv[1]==NULL||argv[2]==NULL) //ve si ingreso mas de dos argumento o menos de dos, y si el primer y segundo argumento es NULL
  {
	   printf("\t/*\t\tError en el argumento\t\t */\n\t/*\t\t Ingrese dos numeros\t\t */ \n\t/* Cantidad de repeticiones y tamao del arreglo */\n");
	   return 0;
   }

 rep=atoi(argv[1]);
 n=atoi(argv[2]); 				//atoi convierte el valor del argumento de la posicion 1 en entero
  if(n<=0||n>MAXN||rep>MAXREP||rep<0)					//ve si el numero es negativo, si lo es retorna error
	   {
	   printf("\t/*\t  Error en el argumento\t\t  */\n\t/*  ingrese un numeros enteros positivos  */\n\t/*\tRepeticiones menor que %d\t  */\n\t/*    Tamao de arreglo menor que %d\t  */ \n",MAXREP,MAXN);
	   return 0;
   }


 

/******************************************************************************************************/
/******************************************************************************************************/

printf("Tarea 2 EDA\n");



archivo1=fopen("archivo1.dat","w");
n2=(int)(ceil((1+(3.3)*log10(rep))));   //La funcin ceil retorna el resultado de la funcin "techo" de x.
 
rango=(int *)malloc((n2+1) * sizeof(int)); //Solicita memoria para crear el arreglo
if (rango == NULL)					  //Ve si el arreglo fue o no creado
	{
	printf("Error: no haba memoria");    //Si no fue creado termina el programa
	exit(-1);
	}

for(i=0;i<=n2;i++)
	 rango[i]=0;
rango2=(int *)malloc((n2+1) * sizeof(int)); //Solicita memoria para crear el arreglo
if (rango2 == NULL)					  //Ve si el arreglo fue o no creado
	{
	printf("Error: no haba memoria");    //Si no fue creado termina el programa
	exit(-1);
	}

for(i=0;i<=n2;i++)
	 rango2[i]=0;

tiempos = (int *)malloc(rep * sizeof(int)); //Solicita memoria para crear el arreglo
if (tiempos == NULL)					  //Ve si el arreglo fue o no creado
	{
	printf("Error: no haba memoria");    //Si no fue creado termina el programa
	exit(-1);
	}
tiempos2 = (int *)malloc(rep * sizeof(int)); 	//Solicita memoria para crear el arreglo
if (tiempos2 == NULL)				//Ve si el arreglo fue o no creado
	{
	printf("Error: no haba memoria");    //Si no fue creado termina el programa
	exit(-1);
	}

//********************************************************************************************************************************************************************************
//********************************************************************************************************************************************************************************
//********************************************************************************************************************************************************************************/



for(i=0;i<rep;i++)				//secuencia de repeticion de ordenamiento del arreglo, de 0 a 9
	{

	arreglo=crearreglo(n);  //crea el arreglo "arreglo" con n numeros
	
	gettimeofday(&ttii, NULL );   //Funsion que toma el tiempo inicial y lo guarda en la structura ttii
	heapsort(arreglo,n);			  //Se llama a la funcion para ordenar el arreglo "arreglo" de "n" numeros
	gettimeofday(&ttff, NULL );  //Funsion que toma el tiempo final y lo guarda en la structura ttff
	free(arreglo);					//libera la memoria	

	ti = (int)ttii.tv_sec;      //tiempo inicial en segundos
	mici = (int)ttii.tv_usec;   //tiempo inicial en microsegundos
	tf = (int)ttff.tv_sec;      //tiempo final en segundos
	micf = (int)ttff.tv_usec;   //tiempo final en microsegundos


	if((micf-mici)<0){					//ve si los microsegundos finales son menor o mayor
										//si son menores, resta un segundo a la diferencia de segundos, y resta los mici con los micf
									//debido a que al pasar de 0:00:999999 a 0:01 solo a pasado un microsegundo
										//si son mayores, resta los micf con los micf
			dfm=(((double)mici-(double)micf)/MICSEC); //guarda la diferencia de microsegundos y la transforma en segundos
			tiempos[i]=(int)((tf-ti-1+dfm)*MICSEC);

			}

		else{
			dfm=(((double)micf-(double)mici)/MICSEC);
			tiempos[i]=(int)((tf-ti+dfm)*MICSEC);
		}

	}

//********************************************************************************************************************************************************************************
//********************************************************************************************************************************************************************************
//********************************************************************************************************************************************************************************//


	
for(i=0;i<rep;i++)			//secuencia de repeticion de ordenamiento del arreglo, de 0 a 9
	{
	arreglo=crearreglo(n);

	gettimeofday(&ttii, NULL );     //Funsion que toma el tiempo inicial y lo guarda en la structura ttii
	quickSort(arreglo,0,n);   //Se llama a la funcion para ordenar el arreglo "arreglo" de "n" numeros
	gettimeofday(&ttff, NULL );     //Funsion que toma el tiempo final y lo guarda en la structura ttff
	free(arreglo);					//libera la memoria
 
	ti = (int)ttii.tv_sec;      //tiempo inicial en segundos
	mici = (int)ttii.tv_usec;   //tiempo inicial en microsegundos
	tf = (int)ttff.tv_sec;      //tiempo final en segundos
	micf = (int)ttff.tv_usec;   //tiempo final en microsegundos
		
	if((micf-mici)<0)	//ve si los microsegundos finales son menor o mayor
		{		//si son menores, resta un segundo a la diferencia de segundos, y resta los mici con los micf
				//debido a que al pasar de 0:00:999999 a 0:01 solo a pasado un microsegundo
				//si son mayores, resta los micf con los micf 
		dfm=(((double)mici-(double)micf)/MICSEC); //guarda la diferencia de microsegundos y la transforma en segundos
		tiempos2[i]=(int)((tf-ti-1+dfm)*MICSEC);
		}
	else
		{
	
			dfm=(((double)micf-(double)mici)/MICSEC);
			tiempos2[i]=(int)((tf-ti+dfm)*MICSEC);
		}

	}

//********************************************************************************************************************************************************************************
//********************************************************************************************************************************************************************************
//********************************************************************************************************************************************************************************/

	


	
	for(i=0;i<rep;i++)        //busca el tiempo mayor y el tiempo menor para el heapsort y quicksort
		{
		if(tiempos[i]<menor)
	   		menor=tiempos[i];
	   	if(tiempos2[i]<menor2)
	   		menor2=tiempos2[i];
		if(tiempos[i]>mayor)
	   		mayor=tiempos[i];
	   	if(tiempos2[i]>mayor2)
	   		mayor2=tiempos2[i];

		}
		
	ranguito=((double)mayor-(double)menor)/n2;    //variable que contiene el tamao de cada rango para el heapsort
	ranguito2=((double)mayor2-(double)menor2)/n2;  //variable que contiene el tamao de cada rango para el quicksort
	printf("\nTiempos heapsort\nMayor:%d Menor:%d Diferencia por rango:%f Numero de Rango:%d\n",mayor,menor,ranguito,n2);
	printf("\nTiempos Quicksort\nMayor:%d Menor:%d Diferencia por rango:%f Numero de Rango:%d\n",mayor2,menor2,ranguito2,n2);

		for(i=0;i<rep;i++)   //compara los tiempos para organizarlos en un arreglo segun el rango en que estan
			{
			for(k=0;k<=n2;k++)  //compara los tiempo del heapsort
				{
					if(((double)tiempos[i])<=((double)menor+((k+1)*ranguito)))
					{
					rango[k]=rango[k]+1;
	   				break;
					}
				}
			for(j=0;j<=n2;j++)  //compara los tiempos del quicksort
				{

				if(((double)tiempos2[i])<=((double)menor2+((j+1)*ranguito2)))
					{
					rango2[j]=rango2[j]+1;
	   				break;
					}
				}

			}
	rango[n2-1]=rango[n2]+rango[n2-1]; // en algunos casos el ultimo numero lo dejaba fuera del rango.
	rango2[n2-1]=rango2[n2]+rango2[n2-1]; // en algunos casos el ultimo numero lo dejaba fuera del rango.
	rango[n2]=0;                          // despues de sumarlo al casillero anterior le doy el valor 0
	rango2[n2]=0;						  // despues de sumarlo al casillero anterior le doy el valor 0
	fprintf(archivo1,"%f\t%d\t\t%f\t%d\n",(double)(menor-ranguito),0,(double)(menor2-ranguito2),0); // le doy el valor 0 al rango [0-1] para que en el grafico la primera barra tengo la linea izquierda
								//de la misma forma le ingreso un valor 0 al rango [n2] para que el grafico despliegue la ultima linea derecha
	for(i=0;i<=n2;i++)		//imprimo los valores de cada rango en el archivo "archivo1.dat" que luego se graficarn con gnuplot
	{
		fprintf(archivo1,"%f\t%d\t\t%f\t%d\n",(double)(menor+i*ranguito),rango[i],(double)(menor2+i*ranguito2),rango2[i]);
		if(i<n2)
		printf("rango %2d heapsort:%3d \tquicksort:%3d\n",i+1,rango[i],rango2[i]);
	}
	printf("\nCreated by Victor Magaa & Shamir Escobar\n");
	fclose(archivo1); //cierra el flujo del archivo.
	

	system("gnuplot grafico.gnu"); //ejecuta el programa externo gnuplot que grafica los datos generados por el prograa

}



int *crearreglo(int n)    //Funcion que crea el arreglo para n numeros
	 {
int *arreglo,i;			//arreglo: puntero donde se guardara el arreglo
time_t semilla;			//variable de tiempo que ayudar al rand() para crear numeros aleatorios
srand(rand()+time(&semilla));   // Cada nmero generado vendr de una secuencia distinta: "ms aleatorio",adems de la semilla de tiempo
			//Adems la semilla provocar que tampoco sean iguales los numeros ninguna vez que se ejecute el programa
arreglo = (int *)malloc(n * sizeof(int)); //Solicita memoria para crear el arreglo
if (arreglo == NULL)					  //Ve si el arreglo fue o no creado
	{
	printf("Error: no haba memoria");    //Si no fue creado termina el programa
	exit(-1);
	}
for (i = 0; i < n; i++)                       	//Ciclo que llena el arreglo con numeros aleatorios
arreglo[i]=(1+(100000.0*(rand())/(RAND_MAX+1.0)));
return arreglo;					//La funsion retorna el arreglo creado y llenado

}





